//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color3  LimeGreen  
#property indicator_color4  DimGray
#property indicator_color5  Orange
#property indicator_color6  LimeGreen
#property indicator_width6  2
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    MomPeriod    =  14;
extern int    MomPrice     = PRICE_CLOSE;
extern int    MinMaxPeriod = 100;
extern double LevelUp      =  80;
extern double LevelDown    =  20;
extern bool   Interpolate  = true;

//
//
//
//
//

double momMin[];
double momMax[];
double momLUp[];
double momLMi[];
double momLDn[];
double mom[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,momMin); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1,momMax); SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,momLUp);
   SetIndexBuffer(3,momLMi);
   SetIndexBuffer(4,momLDn);
   SetIndexBuffer(5,mom);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
      IndicatorShortName(timeFrameToString(timeFrame)+" velocity fl ("+MomPeriod+","+DoubleToStr(LevelDown,2)+","+DoubleToStr(LevelUp,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { momMin[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         mom[i]    = iMomentumS(iMA(NULL,0,1,0,MODE_SMA,MomPrice,i),MomPeriod,1,2,i);
         momMin[i] = mom[ArrayMinimum(mom,MinMaxPeriod,i)];
         momMax[i] = mom[ArrayMaximum(mom,MinMaxPeriod,i)];
            double range = momMax[i]-momMin[i];
               momLDn[i] = momMin[i]+range*LevelDown/100.0;
               momLMi[i] = momMin[i]+range*0.5;
               momLUp[i] = momMin[i]+range*LevelUp/100.0;
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         momMin[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,0,y);
         momMax[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,1,y);
         momLUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,2,y);
         momLMi[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,3,y);
         momLDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,4,y);
         mom   [i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,5,y);
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               momMin[i+k] = momMin[i] + (momMin[i+n] - momMin[i])*k/n;
               momMax[i+k] = momMax[i] + (momMax[i+n] - momMax[i])*k/n;
               momLUp[i+k] = momLUp[i] + (momLUp[i+n] - momLUp[i])*k/n;
               momLMi[i+k] = momLMi[i] + (momLMi[i+n] - momLMi[i])*k/n;
               momLDn[i+k] = momLDn[i] + (momLDn[i+n] - momLDn[i])*k/n;
               mom[i+k]    = mom[i]    + (mom[i+n]    - mom[i]   )*k/n;
            }
   }
   return(0);
         
}

//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workMom[];
double iMomentumS(double price, double length, double powSlow, double powFast, int i)
{
   if (ArraySize(workMom)!=Bars) ArrayResize(workMom,Bars);
      i = Bars-i-1; workMom[i] = price;
      
      //
      //
      //
      //
      //
      
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;
         for(int k=0; k<length; k++)
         {
            double weight = length-k;
               suma  += workMom[i-k] * MathPow(weight,powSlow);
               sumb  += workMom[i-k] * MathPow(weight,powFast);
               sumwa += MathPow(weight,powSlow);
               sumwb += MathPow(weight,powFast);
         }
   return(sumb/sumwb-suma/sumwa);
}  


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}